#ifndef MINI_IMU_9_H_
#define MINI_IMU_9_H_

#include <propeller.h>
#include "I2CBus.h"
#include "MiniIMU9Accel.h"
#include "MiniIMU9Compass.h"
#include "MiniIMU9Gyro.h"

typedef struct vector
{
	int16_t x, y, z;
}vector;

class MiniIMU9
{
public:
	MiniIMU9Accel 		m_accel;
	MiniIMU9Compass 	m_compass;
	MiniIMU9Gyro		m_gyro;

private:
	int m_ready;
	vector m_acc;
	vector m_mag;
	vector m_gyr;
	vector m_magMax;
	vector m_magMin;

public:
	MiniIMU9();
	~MiniIMU9();
	void Init(I2C& bus, int aUpdate=0, int rate=50);

	int IsOnline();
	int GetHeading();
	vector GetAccelVector();
	vector GetMagVector();

private:
	int 	ComputeHeading();

};


#endif

